unit U_GetDllForm;

interface

uses
  Windows, Messages, forms, OleCtnrs, DateUtils, SysUtils, ADODB, dxCore,
  ActiveX, IniFiles, System.Classes;

function GetDllForm(App: Tapplication; FormH: hwnd; FormID: integer; Language: integer; WinStyle: integer; GCode: Pchar; GName: Pchar; DataBase: Pchar; Title: PChar; Parameters1: PChar; Parameters2: PChar; Parameters3: PChar; Parameters4: PChar; Parameters5: PChar; Parameters6: PChar; Parameters7: PChar; Parameters8: PChar; Parameters9: PChar; Parameters10: PChar; DataBaseStr: PChar): hwnd; export; stdcall;

function ConnData(): Boolean;

//function GetsysParam(muserId: pchar; fparam1: pchar): Boolean;

implementation

uses
  U_DataLink, U_globalVar, U_iniParam, U_TradeMachInsp, U_ProductJYHZList,
  U_DeviceJkTest, U_TradeClothInspList, U_MachRollMain, U_TradePack,
  U_DjdDjClList, U_FormLayOutDesign, U_TradeClothInspList_Auto;

       /////////////////////////////////////////////////////////////////
      //         功能说明:取Dll中得窗体                              //
     //        参数说明：App>>调用应用程序；                        //
    //                 FormH>>调用窗口句柄 ；                      //
   //                 FormID>>窗口号;                             //
  //                 Language>>语言种类;                         //
 //                 WinStyle>>窗口类型；                        //
/////////////////////////////////////////////////////////////////

function GetDllForm(App: Tapplication; FormH: hwnd; FormID: integer; Language: integer; WinStyle: integer; GCode: Pchar; GName: Pchar; DataBase: Pchar; Title: PChar; Parameters1: PChar; Parameters2: PChar; Parameters3: PChar; Parameters4: PChar; Parameters5: PChar; Parameters6: PChar; Parameters7: PChar; Parameters8: PChar; Parameters9: PChar; Parameters10: PChar; DataBaseStr: PChar): hwnd;
var
  i: Integer;
  bFound: Boolean;
  mnewHandle: hwnd;
  mstyle: TFormStyle;     // 0:子窗口; 1：普通窗口
  mstate: TWindowState;
  mborderstyle: TFormBorderStyle;
  thread: Tthread;
begin
  mnewHandle := 0;
  DName := PChar(GName);
  DCode := PChar(GCode);
  DdataBase := DataBase;
  DTitCaption := Title;
  DParameters1 := Parameters1;
  DParameters2 := Parameters2;
  DParameters3 := Parameters3;
  DParameters4 := Parameters4;
  DParameters5 := Parameters5;
  DParameters6 := Parameters6;
  DParameters7 := Parameters7;
  DParameters8 := Parameters8;
  DParameters9 := Parameters9;
  DParameters10 := Parameters10;
  gScanBarcodeMaxLen := 0;

  SetLength(fDllFileName, 255);
  GetModuleFileName(HInstance, PChar(fDllFileName), Length(fDllFileName));
  fDllFileName := ExtractFileName(PChar(fDllFileName));
  gDllFileCaption := '指示单打卷包装';
  MainApplication := App;
  DCurHandle := FormH;
  IsDelphiLanguage := Language;

  Application := TApplication(App);
  DCurHandle := 0;
   //赋值链接字符串
  SetLength(server, 255);
  SetLength(dtbase, 255);
  SetLength(user, 255);
  SetLength(pswd, 255);

  if trim(DataBaseStr) = '' then
  begin
    server := '101.132.143.144,7781';
   // dtbase := 'jingpinjydata';
//    dtbase := 'rtbasicsdata';
    dtbase := 'juxiejydata';
    user := 'rtsa';
    pswd := 'rightsoft@5740';
    DConString := 'Provider=SQLOLEDB.1;Password=' + pswd + ';Persist Security Info=True;User ID=' + user + ';Initial Catalog=' + dtbase + ';Data Source=' + server;
//   DParameters1:='高权限';
  end
  else
  begin
    DConString := DataBaseStr;
  end;

//  if not ConnData() then
//  begin
//    result := 0;
//    exit;
//  end;

  gConString := DConString;


//    thread:=TThread.CreateAnonymousThread(
//    procedure
//    begin
//      TThread.Synchronize(nil,
//        procedure
//        begin
  if not ConnData() then
  begin
    exit;
  end;
  if IsINIFile() then
    ReadINIFile()
  else
    WriteINIFile;

//        end)
//    end);
//
//   thread.FreeOnTerminate := True;
//   thread.Start;

  GetsysParam(DataLink_TradeInsp.AdoDataLink, DataLink_TradeInsp.ThreeColorBase, '', '');

   // 定义窗口类型 、状态
//  if WinStyle = 0 then
//  begin
  mstyle := fsMDIChild;
  mstate := wsMaximized;
  mborderstyle := bsSizeable;
//  end
//  else
//  begin
//    mstyle := fsNormal;
//    mstate := wsNormal;
//    mborderstyle := bsSizeable;
//  end;
  bFound := False;
  if FormID <> 10000 then
  begin
    for i := 0 to Application.MainForm.MDIChildCount - 1 do
    begin
      if Application.MainForm.MDIChildren[i].Caption = Title then
      begin
        mnewHandle := Application.MainForm.MDIChildren[i].Handle;
        Application.MainForm.MDIChildren[i].BringToFront;
        bFound := True;
        Result := mnewHandle;
        exit;
      end;
    end;
  end;
  /////////////////////
  //调用子模块窗口
  case FormID of
    2:  //测试
      begin
        with TfrmDeviceJkTest.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10)) do       //
        begin
          fFormID := FormID;
          FormStyle := mstyle;
          WindowState := mstate;
          BorderStyle := mborderstyle;
          mnewHandle := Handle;
        end;
      end;
//    111:  //机台检验
//      begin
//         form2:=tform2.create(Application.MainForm) ;
//         with form2 do
//         begin
//             WindowState := mstate;
//            BorderStyle := mborderstyle;
//            mnewHandle := Handle;
//           // show;
//         end;
//      end;
    1:  //机台检验
      begin
        with TfrmMachRollMain.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10)) do       //
        begin
          fFormID := FormID;
          WindowState := mstate;
          BorderStyle := mborderstyle;
          mnewHandle := Handle;
        end;
      end;
    121:  //布匹打包
      begin
        with TfrmTradePack.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10), FormID) do       //
        begin
          fFormID := FormID;
         // FormStyle := mstyle;
          WindowState := mstate;
          BorderStyle := mborderstyle;
          mnewHandle := Handle;
        end;
      end;
    211:  //检验信息管理
      begin
        with TfrmTradeClothInspList.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10), FormID) do       //
        begin
          fFormID := FormID;
          FormStyle := mstyle;
          WindowState := mstate;
          BorderStyle := mborderstyle;
          mnewHandle := Handle;
        end;
      end;
    221:  //检验信息管理——自动打印标签
      begin
        with TfrmTradeClothInspList_Auto.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10), FormID) do       //
        begin
          fFormID := FormID;
          FormStyle := mstyle;
          WindowState := mstate;
          BorderStyle := mborderstyle;
          mnewHandle := Handle;
        end;
      end;
    212:  //检验信息管理
      begin
        with TfrmProductJYHZList.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10), FormID) do       //
        begin
          fFormID := FormID;
        //  FormStyle := mstyle;
          WindowState := mstate;
          BorderStyle := mborderstyle;
          mnewHandle := Handle;
        end;
      end;
    213:  //打卷和打包产量
      begin
        with TfrmDjdDjClList.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10), FormID) do       //
        begin
          fFormID := FormID;
       //   FormStyle := mstyle;
          WindowState := mstate;
          BorderStyle := mborderstyle;
          mnewHandle := Handle;
        end;
      end;
    10000:
      begin
        for i := 0 to application.MainForm.MDIChildCount - 1 do
        begin
          if application.MainForm.MDIChildren[i].Caption = Title then
          begin
            application.MainForm.MDIChildren[i].Close;
          end;
        end;
      end;
  end;

  Result := mnewHandle;
end;

//function GetsysParam(muserId: pchar; fparam1: pchar): Boolean;
//begin
//  result := true;
//  exit;
//  //////////////////////////////
////  shortDateFormat := 'yyyy-MM-dd';
//  //服务器日期
//  with DataLink_TradeInsp.AdoDataLink do
//  begin
//    close;
//    sql.Clear;
//    sql.Add('select getDate()as dt');
//    open;
//    DServerDate := fieldByName('dt').AsDatetime;
//  end;
//  result := true;
//end;

//===========================================================
  //建立数据库连接池
//===========================================================

function ConnData(): Boolean;
var
  IniFile: TIniFile;
begin
  try
    IniFile := TIniFile.Create(ExtractFilePath(Application.ExeName) + 'SYSTEMSET.INI');
    PicSvr := IniFile.ReadString('SERVER', '服务器地址', '127.0.0.1');
    UserDataFlag := IniFile.ReadString('SERVER', '服务器地址类型', '-1');
  finally
    IniFile.Free;
  end;
  if not Assigned(DataLink_TradeInsp) then
    DataLink_TradeInsp := TDataLink_TradeInsp.Create(Application);
  try
    with DataLink_TradeInsp.ADOLink do
    begin
      if not Connected then
      begin
       // Connected := false;
        ConnectionString := DConString;
        LoginPrompt := false;
       // Connected := true;
        open;
      end;
    end;
    Result := true;
  except
    Result := false;
    application.MessageBox('数据库连接失败！', '错误', mb_Ok + MB_ICONERROR);
  end;

end;

initialization
  CoInitialize(nil);
  dxUnitsLoader.Initialize;


finalization
  DataLink_TradeInsp.Free;
  application := NewDllApp;
  dxUnitsLoader.Finalize;

end.

